static const std::unordered_map<u32, GBASaveType> GbaCrcSaveTypeOverrides =
{
	{ 0xEF365600, GBASaveType::SRAM },
	{ 0xE905937F, GBASaveType::FLASH512 },
	{ 0x689CAF43, GBASaveType::SRAM },
	{ 0x4E0F10FA, GBASaveType::EEPROM },
	{ 0x106ED779, GBASaveType::EEPROM },
	{ 0x91344285, GBASaveType::SRAM },
	{ 0xBA1F514A, GBASaveType::NONE },
	{ 0x11870BD9, GBASaveType::SRAM },
	{ 0x86A602AB, GBASaveType::NONE },
	{ 0x9D5E128C, GBASaveType::SRAM },
	{ 0xD05C86BB, GBASaveType::NONE },
	{ 0x0D72F2CC, GBASaveType::SRAM },
	{ 0xCA9B82DD, GBASaveType::SRAM },
	{ 0x28BAA30E, GBASaveType::SRAM },
	{ 0x35536183, GBASaveType::SRAM },
	{ 0xF5C8D8E8, GBASaveType::SRAM },
	{ 0x93B6599E, GBASaveType::SRAM },
	{ 0x284E3092, GBASaveType::SRAM },
	{ 0xE8156354, GBASaveType::SRAM },
	{ 0xD97DBFEC, GBASaveType::SRAM },
	{ 0xD0C91F74, GBASaveType::SRAM },
	{ 0x3D803E41, GBASaveType::EEPROM },
	{ 0x40A48276, GBASaveType::EEPROM },
	{ 0x10F9EDA4, GBASaveType::EEPROM },
	{ 0x26321120, GBASaveType::EEPROM },
	{ 0x2C79C2DE, GBASaveType::EEPROM },
	{ 0x639E9D3B, GBASaveType::EEPROM },
	{ 0x153F73D1, GBASaveType::NONE },
	{ 0xF74C1FA3, GBASaveType::NONE },
	{ 0x3F15FEAA, GBASaveType::NONE },
	{ 0x3FCAF2D0, GBASaveType::EEPROM },
	{ 0x8DD750EF, GBASaveType::EEPROM },
	{ 0x2C613DEF, GBASaveType::NONE },
	{ 0x285FE485, GBASaveType::EEPROM },
	{ 0xB61F99D4, GBASaveType::EEPROM },
	{ 0xEEA68C2E, GBASaveType::EEPROM },
	{ 0x6E140BFA, GBASaveType::EEPROM },
	{ 0x01B4D95E, GBASaveType::EEPROM },
	{ 0xF87EA3C3, GBASaveType::EEPROM },
	{ 0xE718D850, GBASaveType::EEPROM },
	{ 0xBEE3055A, GBASaveType::EEPROM },
	{ 0x4EF93D41, GBASaveType::EEPROM },
	{ 0x6A5BD4F0, GBASaveType::EEPROM },
	{ 0x170CC574, GBASaveType::EEPROM },
	{ 0xDFF9A0B1, GBASaveType::NONE },
	{ 0x59F208FC, GBASaveType::EEPROM },
	{ 0x3524F206, GBASaveType::NONE },
	{ 0x50927F3E, GBASaveType::EEPROM },
	{ 0xB99D538B, GBASaveType::SRAM },
	{ 0xFB67EFBC, GBASaveType::SRAM },
	{ 0xC90732D5, GBASaveType::NONE },
	{ 0xE144DED2, GBASaveType::EEPROM },
	{ 0xE37A0705, GBASaveType::NONE },
	{ 0xA519FEB5, GBASaveType::EEPROM },
	{ 0xE0E153B7, GBASaveType::SRAM },
	{ 0x3A1E789A, GBASaveType::SRAM },
	{ 0x88C1B562, GBASaveType::SRAM },
	{ 0x247EEB20, GBASaveType::SRAM },
	{ 0x379B3248, GBASaveType::SRAM },
	{ 0xE0C4FD69, GBASaveType::SRAM },
	{ 0x521B3091, GBASaveType::SRAM },
	{ 0x125C2E01, GBASaveType::SRAM },
	{ 0x5264C730, GBASaveType::SRAM },
	{ 0xB789DAC5, GBASaveType::SRAM },
	{ 0xC0E9EEBE, GBASaveType::SRAM },
	{ 0x60C38E52, GBASaveType::SRAM },
	{ 0x91B16892, GBASaveType::SRAM },
	{ 0x5F595157, GBASaveType::SRAM },
	{ 0x529F06A4, GBASaveType::SRAM },
	{ 0x1B8713C7, GBASaveType::SRAM },
	{ 0x2A524221, GBASaveType::SRAM },
	{ 0x0BA2FD1F, GBASaveType::SRAM },
	{ 0xF0C10E72, GBASaveType::SRAM },
	{ 0xCD9D8972, GBASaveType::SRAM },
	{ 0x335C5855, GBASaveType::SRAM },
	{ 0x4A805ED1, GBASaveType::SRAM },
	{ 0x93D3B218, GBASaveType::SRAM },
	{ 0x9DECC754, GBASaveType::SRAM },
	{ 0x1127B83E, GBASaveType::NONE },
	{ 0xB4090702, GBASaveType::EEPROM },
	{ 0xCE2B48C4, GBASaveType::EEPROM },
	{ 0xF8AF3359, GBASaveType::SRAM },
	{ 0xD38763E1, GBASaveType::SRAM },
	{ 0xB40D6854, GBASaveType::SRAM },
	{ 0x8146A270, GBASaveType::SRAM },
	{ 0x55CAE46A, GBASaveType::NONE },
	{ 0x2C00B4E6, GBASaveType::SRAM },
	{ 0xA7A84C31, GBASaveType::EEPROM512 },
	{ 0xB107C73D, GBASaveType::EEPROM512 },
	{ 0xBA829EAC, GBASaveType::EEPROM512 },
	{ 0x14E3EBCC, GBASaveType::EEPROM512 },
	{ 0xA934C4EE, GBASaveType::EEPROM },
	{ 0xE37CA939, GBASaveType::EEPROM },
	{ 0x709B5289, GBASaveType::EEPROM },
	{ 0x03294511, GBASaveType::EEPROM512 },
	{ 0x9AF01F01, GBASaveType::EEPROM },
	{ 0x5F1E5A48, GBASaveType::EEPROM512 },
	{ 0x6CD93829, GBASaveType::EEPROM },
	{ 0x92FDB8D6, GBASaveType::EEPROM512 },
	{ 0xFBFF3F04, GBASaveType::EEPROM },
	{ 0xF5801BD8, GBASaveType::EEPROM512 },
	{ 0x536669C1, GBASaveType::SRAM },
	{ 0xAD17D41E, GBASaveType::SRAM },
	{ 0x81462ABA, GBASaveType::SRAM },
	{ 0x5A5EF8E3, GBASaveType::SRAM },
	{ 0x8EE0ED6F, GBASaveType::SRAM },
	{ 0xAC355418, GBASaveType::SRAM },
	{ 0x95CCC956, GBASaveType::NONE },
	{ 0xF424858F, GBASaveType::NONE },
	{ 0x922D805A, GBASaveType::NONE },
	{ 0x7960926C, GBASaveType::SRAM },
	{ 0x5B8AAA03, GBASaveType::SRAM },
	{ 0x25B0B122, GBASaveType::SRAM },
	{ 0xC1F2B5EC, GBASaveType::SRAM },
	{ 0x872BC075, GBASaveType::NONE },
	{ 0x0A517352, GBASaveType::SRAM },
	{ 0x7E90CEA2, GBASaveType::SRAM },
	{ 0xF1098A5F, GBASaveType::SRAM },
	{ 0x85C837AF, GBASaveType::SRAM },
	{ 0x257E49F9, GBASaveType::NONE },
	{ 0xD1183501, GBASaveType::EEPROM },
	{ 0xABAF519C, GBASaveType::EEPROM },
	{ 0xA79872FE, GBASaveType::NONE },
	{ 0xB3780A4F, GBASaveType::EEPROM },
	{ 0x68076B62, GBASaveType::EEPROM },
	{ 0x4E63DCE0, GBASaveType::FLASH512 },
	{ 0xE6F5BDD5, GBASaveType::FLASH512 },
	{ 0xD9F19D76, GBASaveType::SRAM },
	{ 0xD125A6BB, GBASaveType::SRAM },
	{ 0xC4838CFA, GBASaveType::EEPROM },
	{ 0x7EE24793, GBASaveType::EEPROM },
	{ 0x41E7180E, GBASaveType::EEPROM },
	{ 0xECE42D0E, GBASaveType::EEPROM },
	{ 0xFFDA95BE, GBASaveType::EEPROM },
	{ 0xB7F022B9, GBASaveType::EEPROM },
	{ 0x1D910A62, GBASaveType::EEPROM },
	{ 0xF094A4CB, GBASaveType::EEPROM },
	{ 0x9CD07025, GBASaveType::EEPROM },
	{ 0xBAA4A82B, GBASaveType::EEPROM },
	{ 0xC8C889E2, GBASaveType::EEPROM },
	{ 0xDEA3B767, GBASaveType::SRAM },
	{ 0xA47246AE, GBASaveType::SRAM },
	{ 0xD2B431F8, GBASaveType::SRAM },
	{ 0x9D76826F, GBASaveType::SRAM },
	{ 0x2653401A, GBASaveType::SRAM },
	{ 0xB3005195, GBASaveType::SRAM },
	{ 0xAA14B198, GBASaveType::EEPROM },
	{ 0x195D7EA7, GBASaveType::EEPROM },
	{ 0xEBF89B0D, GBASaveType::EEPROM },
	{ 0x40958C2C, GBASaveType::EEPROM },
	{ 0x304BDFC3, GBASaveType::EEPROM },
	{ 0xA0EBB191, GBASaveType::NONE },
	{ 0x0E2ACA9E, GBASaveType::EEPROM },
	{ 0x526FDFFF, GBASaveType::EEPROM },
	{ 0x8EA9AFCC, GBASaveType::EEPROM },
	{ 0xCA893BC4, GBASaveType::NONE },
	{ 0xEC7869AE, GBASaveType::SRAM },
	{ 0x02F51696, GBASaveType::SRAM },
	{ 0x9AD45607, GBASaveType::FLASH512 },
	{ 0xA646601B, GBASaveType::FLASH512 },
	{ 0xFB6C590F, GBASaveType::EEPROM },
	{ 0xE368A67A, GBASaveType::SRAM },
	{ 0x2912E76E, GBASaveType::FLASH512 },
	{ 0x2AD292A4, GBASaveType::FLASH512 },
	{ 0x9A704AF8, GBASaveType::FLASH512 },
	{ 0xD111CC19, GBASaveType::FLASH512 },
	{ 0xAE57B39E, GBASaveType::FLASH512 },
	{ 0x6346FD59, GBASaveType::FLASH512 },
	{ 0x6CE771A5, GBASaveType::EEPROM },
	{ 0xCD2604DD, GBASaveType::EEPROM },
	{ 0xE4628D75, GBASaveType::EEPROM },
	{ 0x86C4F772, GBASaveType::SRAM },
	{ 0x1A1397DE, GBASaveType::SRAM },
	{ 0x96B54925, GBASaveType::EEPROM },
	{ 0xD047FFDF, GBASaveType::EEPROM },
};

static const std::unordered_map<std::string, GBASaveType> GbaGameIdSaveTypeOverrides =
{
	{ "A2GJ", GBASaveType::EEPROM },
	{ "A2HJ", GBASaveType::EEPROM },
	{ "A2IJ", GBASaveType::EEPROM },
	{ "A2JJ", GBASaveType::EEPROM },
	{ "A2OJ", GBASaveType::EEPROM },
	{ "A2QE", GBASaveType::SRAM },
	{ "A2QJ", GBASaveType::SRAM },
	{ "A2SE", GBASaveType::EEPROM },
	{ "A2SP", GBASaveType::EEPROM },
	{ "A2VJ", GBASaveType::EEPROM },
	{ "A2YE", GBASaveType::NONE },
	{ "A3AC", GBASaveType::EEPROM },
	{ "A3DE", GBASaveType::EEPROM512 },
	{ "A3DJ", GBASaveType::EEPROM512 },
	{ "A3IJ", GBASaveType::EEPROM },
	{ "A3NJ", GBASaveType::SRAM },
	{ "A3OJ", GBASaveType::SRAM },
	{ "A4GE", GBASaveType::EEPROM },
	{ "A4GJ", GBASaveType::EEPROM },
	{ "A4LJ", GBASaveType::EEPROM },
	{ "A4VJ", GBASaveType::SRAM },
	{ "A56J", GBASaveType::EEPROM },
	{ "A57J", GBASaveType::SRAM },
	{ "A59J", GBASaveType::EEPROM },
	{ "A5CE", GBASaveType::EEPROM },
	{ "A5CP", GBASaveType::EEPROM },
	{ "A5SJ", GBASaveType::EEPROM },
	{ "A63J", GBASaveType::EEPROM },
	{ "A64J", GBASaveType::EEPROM },
	{ "A6CJ", GBASaveType::SRAM },
	{ "A6GJ", GBASaveType::SRAM },
	{ "A6OE", GBASaveType::EEPROM },
	{ "A6OJ", GBASaveType::EEPROM },
	{ "A6OP", GBASaveType::EEPROM },
	{ "A6RE", GBASaveType::SRAM },
	{ "A82J", GBASaveType::EEPROM },
	{ "A83J", GBASaveType::EEPROM },
	{ "A85J", GBASaveType::EEPROM },
	{ "A87J", GBASaveType::EEPROM },
	{ "A8BS", GBASaveType::EEPROM },
	{ "A8LJ", GBASaveType::SRAM },
	{ "A8OJ", GBASaveType::EEPROM },
	{ "A8RJ", GBASaveType::SRAM },
	{ "A8ZJ", GBASaveType::EEPROM },
	{ "A9BS", GBASaveType::EEPROM },
	{ "A9HJ", GBASaveType::EEPROM },
	{ "A9LJ", GBASaveType::SRAM },
	{ "A9ME", GBASaveType::SRAM },
	{ "A9MP", GBASaveType::SRAM },
	{ "A9TJ", GBASaveType::EEPROM },
	{ "AA2C", GBASaveType::EEPROM },
	{ "AA2E", GBASaveType::EEPROM },
	{ "AA2J", GBASaveType::EEPROM },
	{ "AA2P", GBASaveType::EEPROM },
	{ "AABE", GBASaveType::EEPROM },
	{ "AABJ", GBASaveType::SRAM },
	{ "AABP", GBASaveType::EEPROM },
	{ "AAGJ", GBASaveType::EEPROM },
	{ "AALJ", GBASaveType::EEPROM },
	{ "AANJ", GBASaveType::SRAM },
	{ "AAPJ", GBASaveType::EEPROM },
	{ "AASJ", GBASaveType::EEPROM },
	{ "AAXJ", GBASaveType::EEPROM },
	{ "AB3E", GBASaveType::EEPROM },
	{ "AB4E", GBASaveType::EEPROM },
	{ "AB4J", GBASaveType::EEPROM },
	{ "ABFJ", GBASaveType::SRAM },
	{ "ABGJ", GBASaveType::EEPROM },
	{ "ABJE", GBASaveType::EEPROM },
	{ "ABJP", GBASaveType::EEPROM },
	{ "ABPE", GBASaveType::SRAM },
	{ "AC4J", GBASaveType::EEPROM },
	{ "AC5E", GBASaveType::SRAM },
	{ "ACBE", GBASaveType::EEPROM },
	{ "ACBJ", GBASaveType::EEPROM },
	{ "ACOJ", GBASaveType::EEPROM },
	{ "ACTX", GBASaveType::EEPROM },
	{ "ACTY", GBASaveType::EEPROM },
	{ "AD4P", GBASaveType::SRAM },
	{ "ADDJ", GBASaveType::EEPROM },
	{ "ADPJ", GBASaveType::EEPROM },
	{ "ADQE", GBASaveType::SRAM },
	{ "ADQJ", GBASaveType::SRAM },
	{ "ADQP", GBASaveType::SRAM },
	{ "ADZE", GBASaveType::SRAM },
	{ "AEAJ", GBASaveType::SRAM },
	{ "AECJ", GBASaveType::SRAM },
	{ "AEHJ", GBASaveType::EEPROM },
	{ "AEPP", GBASaveType::EEPROM },
	{ "AEWJ", GBASaveType::EEPROM },
	{ "AF3J", GBASaveType::EEPROM },
	{ "AF7J", GBASaveType::EEPROM },
	{ "AFNJ", GBASaveType::EEPROM },
	{ "AFUJ", GBASaveType::EEPROM },
	{ "AG6J", GBASaveType::SRAM },
	{ "AG9J", GBASaveType::SRAM },
	{ "AGDE", GBASaveType::SRAM },
	{ "AGNJ", GBASaveType::EEPROM },
	{ "AH3E", GBASaveType::SRAM },
	{ "AH3J", GBASaveType::SRAM },
	{ "AH3P", GBASaveType::SRAM },
	{ "AH5J", GBASaveType::SRAM },
	{ "AH7J", GBASaveType::EEPROM },
	{ "AHAJ", GBASaveType::EEPROM },
	{ "AHHE", GBASaveType::EEPROM },
	{ "AHIJ", GBASaveType::EEPROM },
	{ "AHKJ", GBASaveType::SRAM },
	{ "AHMJ", GBASaveType::EEPROM512 },
	{ "AHVJ", GBASaveType::EEPROM },
	{ "AHXJ", GBASaveType::EEPROM },
	{ "AHZJ", GBASaveType::EEPROM },
	{ "AI7J", GBASaveType::EEPROM },
	{ "AISP", GBASaveType::EEPROM },
	{ "AJ3E", GBASaveType::SRAM },
	{ "AJ3P", GBASaveType::SRAM },
	{ "AJKJ", GBASaveType::EEPROM },
	{ "AJWJ", GBASaveType::EEPROM },
	{ "AK7J", GBASaveType::EEPROM },
	{ "AKDJ", GBASaveType::SRAM },
	{ "AKEJ", GBASaveType::SRAM },
	{ "AKGE", GBASaveType::EEPROM },
	{ "AKGJ", GBASaveType::EEPROM },
	{ "AKGP", GBASaveType::EEPROM },
	{ "AKTJ", GBASaveType::EEPROM },
	{ "AKVJ", GBASaveType::EEPROM },
	{ "AL4E", GBASaveType::SRAM },
	{ "AL4J", GBASaveType::SRAM },
	{ "ALFE", GBASaveType::EEPROM },
	{ "ALFJ", GBASaveType::EEPROM },
	{ "ALFP", GBASaveType::EEPROM },
	{ "ALJE", GBASaveType::EEPROM },
	{ "ALNE", GBASaveType::EEPROM },
	{ "ALOE", GBASaveType::EEPROM },
	{ "ALOP", GBASaveType::EEPROM },
	{ "ALQJ", GBASaveType::SRAM },
	{ "ALUE", GBASaveType::EEPROM512 },
	{ "AM7J", GBASaveType::SRAM },
	{ "AMFE", GBASaveType::SRAM },
	{ "AMFJ", GBASaveType::SRAM },
	{ "AMGJ", GBASaveType::EEPROM },
	{ "AMGP", GBASaveType::EEPROM },
	{ "AMHE", GBASaveType::EEPROM },
	{ "AMHJ", GBASaveType::EEPROM },
	{ "AMHP", GBASaveType::EEPROM },
	{ "AMYE", GBASaveType::EEPROM },
	{ "AMYJ", GBASaveType::EEPROM },
	{ "AMYP", GBASaveType::EEPROM },
	{ "AN3E", GBASaveType::EEPROM },
	{ "AN3J", GBASaveType::EEPROM },
	{ "AN3X", GBASaveType::EEPROM },
	{ "AN5J", GBASaveType::EEPROM },
	{ "AN7J", GBASaveType::EEPROM },
	{ "AN8E", GBASaveType::EEPROM },
	{ "AN8J", GBASaveType::EEPROM },
	{ "AN8P", GBASaveType::EEPROM },
	{ "AN9J", GBASaveType::EEPROM },
	{ "ANJE", GBASaveType::EEPROM },
	{ "ANLE", GBASaveType::EEPROM },
	{ "ANNJ", GBASaveType::EEPROM },
	{ "ANOJ", GBASaveType::SRAM },
	{ "ANSJ", GBASaveType::EEPROM },
	{ "ANTJ", GBASaveType::SRAM },
	{ "ANYJ", GBASaveType::SRAM },
	{ "AO2J", GBASaveType::EEPROM },
	{ "AOPJ", GBASaveType::EEPROM },
	{ "AOWE", GBASaveType::EEPROM },
	{ "AOWP", GBASaveType::EEPROM },
	{ "AP9P", GBASaveType::SRAM },
	{ "APNJ", GBASaveType::EEPROM },
	{ "APUJ", GBASaveType::EEPROM },
	{ "AQ2J", GBASaveType::SRAM },
	{ "AQ2P", GBASaveType::SRAM },
	{ "AR8E", GBASaveType::EEPROM512 },
	{ "ARJJ", GBASaveType::EEPROM },
	{ "ARNJ", GBASaveType::EEPROM },
	{ "AROP", GBASaveType::EEPROM512 },
	{ "ASFJ", GBASaveType::EEPROM },
	{ "AT3D", GBASaveType::EEPROM },
	{ "AT3E", GBASaveType::EEPROM },
	{ "AT3F", GBASaveType::EEPROM },
	{ "AT6E", GBASaveType::EEPROM },
	{ "ATBJ", GBASaveType::EEPROM },
	{ "ATDJ", GBASaveType::SRAM },
	{ "ATFP", GBASaveType::EEPROM },
	{ "ATYJ", GBASaveType::EEPROM },
	{ "ATZJ", GBASaveType::SRAM },
	{ "AUCJ", GBASaveType::EEPROM },
	{ "AUEJ", GBASaveType::SRAM },
	{ "AWIJ", GBASaveType::EEPROM },
	{ "AWKJ", GBASaveType::EEPROM },
	{ "AWUE", GBASaveType::EEPROM },
	{ "AWUP", GBASaveType::EEPROM },
	{ "AWXJ", GBASaveType::EEPROM },
	{ "AWZJ", GBASaveType::SRAM },
	{ "AX2E", GBASaveType::EEPROM },
	{ "AX2P", GBASaveType::EEPROM },
	{ "AXBJ", GBASaveType::EEPROM },
	{ "AY2P", GBASaveType::EEPROM },
	{ "AY8E", GBASaveType::SRAM },
	{ "AY8J", GBASaveType::SRAM },
	{ "AY8P", GBASaveType::SRAM },
	{ "AYAJ", GBASaveType::SRAM },
	{ "AYCE", GBASaveType::EEPROM },
	{ "AYCP", GBASaveType::EEPROM },
	{ "AYHE", GBASaveType::EEPROM512 },
	{ "AYLE", GBASaveType::SRAM },
	{ "AYLJ", GBASaveType::SRAM },
	{ "AYMJ", GBASaveType::SRAM },
	{ "AYSJ", GBASaveType::EEPROM },
	{ "AZ2E", GBASaveType::SRAM },
	{ "AZ2J", GBASaveType::SRAM },
	{ "AZAJ", GBASaveType::EEPROM },
	{ "AZBJ", GBASaveType::EEPROM },
	{ "AZLE", GBASaveType::EEPROM },
	{ "AZLJ", GBASaveType::EEPROM },
	{ "AZLP", GBASaveType::EEPROM },
	{ "AZUE", GBASaveType::EEPROM },
	{ "AZUJ", GBASaveType::EEPROM },
	{ "AZUP", GBASaveType::EEPROM },
	{ "B08J", GBASaveType::EEPROM },
	{ "B26E", GBASaveType::EEPROM },
	{ "B2DE", GBASaveType::EEPROM },
	{ "B2DJ", GBASaveType::EEPROM },
	{ "B2DP", GBASaveType::EEPROM },
	{ "B2KJ", GBASaveType::EEPROM },
	{ "B2OJ", GBASaveType::EEPROM },
	{ "B2TE", GBASaveType::EEPROM },
	{ "B34E", GBASaveType::EEPROM },
	{ "B3CJ", GBASaveType::EEPROM },
	{ "B3JE", GBASaveType::NONE },
	{ "B3JP", GBASaveType::NONE },
	{ "B3KJ", GBASaveType::SRAM },
	{ "B3PJ", GBASaveType::EEPROM },
	{ "B3TJ", GBASaveType::EEPROM },
	{ "B3YE", GBASaveType::EEPROM },
	{ "B3YP", GBASaveType::EEPROM },
	{ "B4GJ", GBASaveType::SRAM },
	{ "B4KJ", GBASaveType::EEPROM },
	{ "B4LJ", GBASaveType::EEPROM },
	{ "B4PJ", GBASaveType::EEPROM },
	{ "B4RJ", GBASaveType::EEPROM },
	{ "B4SJ", GBASaveType::SRAM },
	{ "B52P", GBASaveType::EEPROM },
	{ "B53E", GBASaveType::EEPROM },
	{ "B54E", GBASaveType::EEPROM },
	{ "B5AP", GBASaveType::EEPROM },
	{ "B6ME", GBASaveType::EEPROM },
	{ "B7ME", GBASaveType::EEPROM },
	{ "B8AE", GBASaveType::EEPROM },
	{ "B8CE", GBASaveType::SRAM },
	{ "B8CJ", GBASaveType::SRAM },
	{ "B8CP", GBASaveType::SRAM },
	{ "B8SE", GBASaveType::EEPROM },
	{ "BAQP", GBASaveType::EEPROM },
	{ "BAXJ", GBASaveType::SRAM },
	{ "BAZJ", GBASaveType::EEPROM },
	{ "BB2E", GBASaveType::EEPROM },
	{ "BB2P", GBASaveType::EEPROM },
	{ "BBME", GBASaveType::EEPROM },
	{ "BBMJ", GBASaveType::EEPROM },
	{ "BBYE", GBASaveType::EEPROM },
	{ "BBYX", GBASaveType::EEPROM },
	{ "BC2J", GBASaveType::EEPROM },
	{ "BC2S", GBASaveType::EEPROM },
	{ "BCME", GBASaveType::EEPROM },
	{ "BCMJ", GBASaveType::EEPROM },
	{ "BCSP", GBASaveType::EEPROM },
	{ "BDHJ", GBASaveType::SRAM },
	{ "BDKJ", GBASaveType::EEPROM },
	{ "BDTE", GBASaveType::EEPROM },
	{ "BDTJ", GBASaveType::EEPROM },
	{ "BDXE", GBASaveType::EEPROM },
	{ "BDXJ", GBASaveType::EEPROM },
	{ "BDYJ", GBASaveType::SRAM },
	{ "BECJ", GBASaveType::EEPROM },
	{ "BEFE", GBASaveType::EEPROM },
	{ "BEFP", GBASaveType::EEPROM },
	{ "BEJJ", GBASaveType::EEPROM },
	{ "BENE", GBASaveType::EEPROM },
	{ "BENP", GBASaveType::EEPROM },
	{ "BEYE", GBASaveType::EEPROM },
	{ "BEYP", GBASaveType::EEPROM },
	{ "BFCJ", GBASaveType::EEPROM },
	{ "BFEE", GBASaveType::EEPROM },
	{ "BFEP", GBASaveType::EEPROM },
	{ "BFJE", GBASaveType::EEPROM },
	{ "BFJJ", GBASaveType::EEPROM },
	{ "BFMJ", GBASaveType::EEPROM },
	{ "BFQE", GBASaveType::EEPROM },
	{ "BFRP", GBASaveType::EEPROM },
	{ "BG3E", GBASaveType::EEPROM },
	{ "BG8J", GBASaveType::EEPROM },
	{ "BGAJ", GBASaveType::EEPROM },
	{ "BGBJ", GBASaveType::EEPROM },
	{ "BGHJ", GBASaveType::EEPROM },
	{ "BGMJ", GBASaveType::EEPROM },
	{ "BGNJ", GBASaveType::EEPROM },
	{ "BGQE", GBASaveType::EEPROM },
	{ "BGXJ", GBASaveType::EEPROM },
	{ "BH9E", GBASaveType::EEPROM },
	{ "BH9P", GBASaveType::EEPROM },
	{ "BH9X", GBASaveType::EEPROM },
	{ "BHBE", GBASaveType::EEPROM },
	{ "BHBP", GBASaveType::EEPROM },
	{ "BHCJ", GBASaveType::EEPROM },
	{ "BHFJ", GBASaveType::EEPROM },
	{ "BHGE", GBASaveType::EEPROM },
	{ "BHGP", GBASaveType::EEPROM },
	{ "BHLE", GBASaveType::SRAM },
	{ "BHTE", GBASaveType::EEPROM },
	{ "BHTJ", GBASaveType::EEPROM },
	{ "BHUE", GBASaveType::EEPROM },
	{ "BHUP", GBASaveType::EEPROM },
	{ "BIMP", GBASaveType::EEPROM },
	{ "BIMX", GBASaveType::EEPROM },
	{ "BIPJ", GBASaveType::EEPROM },
	{ "BISJ", GBASaveType::EEPROM },
	{ "BITJ", GBASaveType::EEPROM },
	{ "BJPP", GBASaveType::EEPROM },
	{ "BK2J", GBASaveType::SRAM },
	{ "BK3J", GBASaveType::EEPROM },
	{ "BK4J", GBASaveType::SRAM },
	{ "BK5J", GBASaveType::SRAM },
	{ "BKBJ", GBASaveType::SRAM },
	{ "BKCJ", GBASaveType::EEPROM },
	{ "BKCS", GBASaveType::EEPROM },
	{ "BKEJ", GBASaveType::EEPROM },
	{ "BKIJ", GBASaveType::EEPROM },
	{ "BKKJ", GBASaveType::EEPROM },
	{ "BKME", GBASaveType::EEPROM512 },
	{ "BKMJ", GBASaveType::EEPROM512 },
	{ "BKMP", GBASaveType::EEPROM512 },
	{ "BKOJ", GBASaveType::EEPROM },
	{ "BKUJ", GBASaveType::EEPROM },
	{ "BKVJ", GBASaveType::EEPROM },
	{ "BKZE", GBASaveType::EEPROM },
	{ "BKZI", GBASaveType::EEPROM },
	{ "BKZS", GBASaveType::EEPROM },
	{ "BKZX", GBASaveType::EEPROM },
	{ "BL9E", GBASaveType::EEPROM },
	{ "BLDP", GBASaveType::EEPROM },
	{ "BLDS", GBASaveType::EEPROM },
	{ "BLFE", GBASaveType::EEPROM },
	{ "BLIJ", GBASaveType::EEPROM },
	{ "BLME", GBASaveType::EEPROM },
	{ "BLMP", GBASaveType::EEPROM },
	{ "BM2J", GBASaveType::EEPROM },
	{ "BM9J", GBASaveType::SRAM },
	{ "BMDE", GBASaveType::EEPROM },
	{ "BMFE", GBASaveType::EEPROM },
	{ "BMOJ", GBASaveType::SRAM },
	{ "BMPJ", GBASaveType::SRAM },
	{ "BMRJ", GBASaveType::EEPROM },
	{ "BMWJ", GBASaveType::EEPROM },
	{ "BMYJ", GBASaveType::SRAM },
	{ "BMZJ", GBASaveType::EEPROM },
	{ "BMZP", GBASaveType::EEPROM },
	{ "BNBE", GBASaveType::EEPROM },
	{ "BNGJ", GBASaveType::SRAM },
	{ "BNMJ", GBASaveType::SRAM },
	{ "BO2J", GBASaveType::EEPROM },
	{ "BO3J", GBASaveType::EEPROM },
	{ "BO8K", GBASaveType::EEPROM },
	{ "BOBJ", GBASaveType::SRAM },
	{ "BOVJ", GBASaveType::EEPROM },
	{ "BP3J", GBASaveType::EEPROM },
	{ "BPIE", GBASaveType::EEPROM },
	{ "BPNJ", GBASaveType::EEPROM },
	{ "BPPE", GBASaveType::SRAM },
	{ "BPPJ", GBASaveType::SRAM },
	{ "BPPP", GBASaveType::SRAM },
	{ "BPQJ", GBASaveType::EEPROM },
	{ "BPVP", GBASaveType::EEPROM },
	{ "BPVX", GBASaveType::EEPROM },
	{ "BPVY", GBASaveType::EEPROM },
	{ "BQAJ", GBASaveType::EEPROM },
	{ "BQBJ", GBASaveType::EEPROM },
	{ "BQSJ", GBASaveType::EEPROM },
	{ "BQTF", GBASaveType::EEPROM },
	{ "BQTP", GBASaveType::EEPROM },
	{ "BQTX", GBASaveType::EEPROM },
	{ "BQVE", GBASaveType::EEPROM },
	{ "BQVP", GBASaveType::EEPROM },
	{ "BQVX", GBASaveType::EEPROM },
	{ "BQZE", GBASaveType::EEPROM },
	{ "BQZP", GBASaveType::EEPROM },
	{ "BREE", GBASaveType::SRAM },
	{ "BREJ", GBASaveType::SRAM },
	{ "BRGE", GBASaveType::EEPROM },
	{ "BRIJ", GBASaveType::SRAM },
	{ "BRLP", GBASaveType::EEPROM },
	{ "BRPJ", GBASaveType::EEPROM },
	{ "BS5J", GBASaveType::EEPROM },
	{ "BSFJ", GBASaveType::EEPROM },
	{ "BSKE", GBASaveType::EEPROM },
	{ "BSKJ", GBASaveType::EEPROM },
	{ "BT2E", GBASaveType::EEPROM },
	{ "BT2P", GBASaveType::EEPROM },
	{ "BT3J", GBASaveType::EEPROM },
	{ "BT4E", GBASaveType::EEPROM },
	{ "BT8E", GBASaveType::EEPROM },
	{ "BT8P", GBASaveType::EEPROM },
	{ "BTAE", GBASaveType::EEPROM },
	{ "BTAJ", GBASaveType::EEPROM },
	{ "BTAP", GBASaveType::EEPROM },
	{ "BTOE", GBASaveType::EEPROM },
	{ "BTVE", GBASaveType::EEPROM },
	{ "BTYE", GBASaveType::EEPROM },
	{ "BUCE", GBASaveType::EEPROM },
	{ "BUFE", GBASaveType::EEPROM },
	{ "BUHJ", GBASaveType::EEPROM512 },
	{ "BUOE", GBASaveType::EEPROM },
	{ "BUOJ", GBASaveType::EEPROM },
	{ "BUOP", GBASaveType::EEPROM },
	{ "BURE", GBASaveType::EEPROM },
	{ "BUZE", GBASaveType::EEPROM },
	{ "BVHJ", GBASaveType::SRAM },
	{ "BWDJ", GBASaveType::EEPROM },
	{ "BWIE", GBASaveType::EEPROM },
	{ "BWIP", GBASaveType::EEPROM },
	{ "BWOP", GBASaveType::EEPROM },
	{ "BWSE", GBASaveType::SRAM },
	{ "BWXJ", GBASaveType::EEPROM },
	{ "BX4E", GBASaveType::EEPROM },
	{ "BX5E", GBASaveType::EEPROM },
	{ "BX5P", GBASaveType::EEPROM },
	{ "BXFD", GBASaveType::EEPROM },
	{ "BXFE", GBASaveType::EEPROM },
	{ "BXFP", GBASaveType::EEPROM },
	{ "BXKE", GBASaveType::SRAM },
	{ "BXKP", GBASaveType::SRAM },
	{ "BY6E", GBASaveType::SRAM },
	{ "BY6J", GBASaveType::SRAM },
	{ "BY6P", GBASaveType::SRAM },
	{ "BYDE", GBASaveType::SRAM },
	{ "BYDP", GBASaveType::SRAM },
	{ "BYPP", GBASaveType::EEPROM },
	{ "BYPX", GBASaveType::EEPROM },
	{ "BYPY", GBASaveType::EEPROM },
	{ "BYSJ", GBASaveType::SRAM },
	{ "BYUE", GBASaveType::EEPROM },
	{ "BYUJ", GBASaveType::EEPROM },
	{ "BYUP", GBASaveType::EEPROM },
	{ "BZFJ", GBASaveType::SRAM },
	{ "BZME", GBASaveType::EEPROM },
	{ "BZMP", GBASaveType::EEPROM },
	{ "BZOJ", GBASaveType::EEPROM },
	{ "BZWJ", GBASaveType::EEPROM },
	{ "FLBJ", GBASaveType::EEPROM },
	{ "FMRJ", GBASaveType::EEPROM },
	{ "FPTJ", GBASaveType::EEPROM },
	{ "MRDK", GBASaveType::FLASH512 },
	{ "RARE", GBASaveType::NONE },
	{ "U32E", GBASaveType::EEPROM },
	{ "U32J", GBASaveType::EEPROM },
	{ "U32P", GBASaveType::EEPROM },
	{ "U33J", GBASaveType::EEPROM },
	{ "U3IE", GBASaveType::EEPROM },
	{ "U3IJ", GBASaveType::EEPROM },
	{ "U3IP", GBASaveType::EEPROM },
};
